Fake Maximization Template and Class Based on a class by Larry Sand.

The Following Is a variation on a class built by Larry Sand that will 
replace the Maximization of a Window with a Fake Maximization.

I am not a template writer nor am I a class writer. These routines were 
written to the best of my abilities. Any comments or suggestions would be 
greatly appreciated.

Jeff Hojka
Marathon Software Co.

Add Template and Enter the global Variable to hold the current Maximize / 
Minimize state of all windows.

4 Files total

FauxMax.tpl
FauxMax.tpw
FauxMac.inc
FauxMax.clw


\Clarion6\3rdParty\Template\FauxMax.tpl

#! -------------------------------------------------------------------------
#TEMPLATE (FakeMaximize, 'FakeMaximize Template Set (ABC)'), FAMILY('ABC')
#! -------------------------------------------------------------------------
#!
#! -------------------------------------------------------------------------
#INCLUDE ('FAUXMAX.TPW')
#! -------------------------------------------------------------------------

\Clarion6\3rdParty\Template\FauxMax.tpw

#EXTENSION(FakeMaximize,'Replace Maximization Routine'),DESCRIPTION('Replace 
Maximization Routine'),MULTI,WINDOW
  #PROMPT('Global Maximze Field (BYTE):',@s50),%FakeGlobalMaximize
#AT(%AfterGlobalIncludes)
  include('fauxMax.Inc'),ONCE
#ENDAT
#AT( %WindowManagerMethodCodeSection, 'Init', '(),BYTE'),PRIORITY(8005)
#IF(INSTRING(',MDI', %WindowStatement, 1, 1))
#IF(INSTRING(',RESIZE', %WindowStatement, 1, 1))
#IF(INSTRING(',MAX', %WindowStatement, 1, 1))
    fMax.Init(%Window, Resizer, 0{PROP:XPOS}, 0{PROP:YPOS}, 0{PROP:WIDTH}, 
0{PROP:HEIGHT}, TRUE, %FakeGlobalMaximize)
#ENDIF
#ENDIF
#ENDIF
#ENDAT
#AT( %DataSection),PRIORITY(1300)
#IF(INSTRING(',MDI', %WindowStatement, 1, 1))
#IF(INSTRING(',RESIZE', %WindowStatement, 1, 1))
#IF(INSTRING(',MAX', %WindowStatement, 1, 1))
fMax FauxMaxClass
#ENDIF
#ENDIF
#ENDIF
#ENDAT
#AT( %ResizerMethodCodeSection, 6, 'Resize', '(),BYTE'),PRIORITY(5001)
#IF(INSTRING(',MDI', %WindowStatement, 1, 1))
#IF(INSTRING(',RESIZE', %WindowStatement, 1, 1))
#IF(INSTRING(',MAX', %WindowStatement, 1, 1))
 %FakeGlobalMaximize = fmax.GetMaximize()
#ENDIF
#ENDIF
#ENDIF
#ENDAT

\Clarion6\3rdParty\LibSrc\FauxMax.Inc

OMIT('_EndOfFauxMax_',_FauxMaxClassIncluded_)
_FauxMaxClassIncluded_ EQUATE(1)

 Include('ABRESIZE.INC'),Once               !WindowResizeClass reference 
needs this header

Event:MDIChildMaximize  Equate(0800Eh)      !WM_APP + 0Eh
FAUX_HWND               Equate(UNSIGNED)

FauxMaxClass  Class,Type,Module('FauxMax.clw'),Link('FauxMax.clw',1), DLL(0)
W               &Window,Protected
hWnd            FAUX_HWND,Protected
wr              &WindowResizeClass,Protected
ThisXpos SIGNED,Protected
ThisYpos SIGNED,Protected
ThisWidth SIGNED,Protected
ThisHeight SIGNED,Protected
MyMaximize      BYTE,Protected

Init         Procedure(Window W, <*WindowResizeClass wr>, signed in_xpos, 
signed in_ypos, signed in_width, signed in_height, Long 
bWatchMDIChildMax=True, BYTE inMaximize)

OnUserMaximize  Procedure(),Byte,Protected,Proc
OnMaximize      Procedure(),Byte,Protected,Proc
GetMaximize     Procedure(),Byte
              End

!_EndOfFauxMax_

\Clarion6\3rdParty\LibSrc\FauxMax.clw

  Member
  Include('fauxMax.inc'),Once

FAUX_RECT                      Group,Type
left                              SIGNED
top                               SIGNED
right                             SIGNED
bottom                            SIGNED
                                End
  Map
   Module('winApi')
    FAUX_GetWindowRect(FAUX_HWND hWnd, *FAUX_RECT 
lpRect),BOOL,Raw,Pascal,Proc,Name('GetWindowRect')
    FAUX_GetParent(FAUX_HWND hWnd),FAUX_HWND,Pascal,Name('GetParent')
    FAUX_MoveWindow(FAUX_HWND hWnd, UNSIGNED x, UNSIGNED y, UNSIGNED cx, 
UNSIGNED cy, BOOL bRedraw),BOOL,Pascal,Proc,Name('MoveWindow')
   End
  End

FauxMaxClass.Init        Procedure(Window W, <*WindowResizeClass wr>, signed 
in_xpos, signed in_ypos, signed in_width, signed in_height, Long 
bWatchMDIChildMax=True, BYTE inMaximize)
  Code
  Self.W   &= W

  self.ThisXPos = in_xpos
  self.ThisYPos = in_ypos
  self.ThisWidth = in_width
  self.ThisHeight = in_height

  If Not Omitted(wr)
    Self.wr  &= wr
  End

  If W{Prop:MDI} And W{Prop:Resize} And W{Prop:Max}
    Self.hWnd = W{prop:Handle}
    Register(Event:Maximize, Address(Self.OnMaximize), Address(Self), W)
    If bWatchMDIChildMax
       Register(Event:MDIChildMaximize, Address(Self.OnUserMaximize), 
Address(Self), W)
    End
    If (inMaximize = 1)
      POST(Event:Maximize)
    END
  else
    self.MyMaximize = inMaximize
  End
  Return

FauxMaxClass.OnUserMaximize   Procedure()!,Byte,Protected,Proc
  Code
  Self.OnMaximize()
  Return 0

FauxMaxClass.GetMaximize Procedure()!,BYTE
  code
  return(self.MyMaximize)

FauxMaxClass.OnMaximize    Procedure()!,Byte,Protected,Proc
rcFCA       Like(FAUX_RECT)
   Code
   If Self.W{Prop:iconize}
     Self.W{Prop:iconize} = False
   End

   FAUX_GetWindowRect(FAUX_GetParent(Self.hWnd), rcFCA)

   IF (Self.MyMaximize = 0)
     FAUX_MoveWindow(Self.hWnd, 0, 0,rcFCA.right-rcFCA.left, 
rcFCA.bottom-rcFCA.top, True)
     self.MyMaximize = 1
   ELSE
     0{PROP:WIDTH} = self.ThisWidth
     0{PROP:HEIGHT} = self.ThisHeight
     0{PROP:YPOS} = self.ThisYpos
     0{PROP:XPOS} = self.ThisXpos
     self.MyMaximize = 0
   END
   If Self.wr &= Null
     Post(Event:Sized)
   Else
     Self.wr.Resize()
   End
   Return 5 !Level:Notify don't call next event handler or accept

